


                                                         A2PS(1L)



NAME
     a2ps - formats an ascii file for printing  in  a  postscript
     printer; very nice and compact format for program listings.

SYNOPSIS
     a2ps [ -b ] [ -f ] [ -i ] [ -n ] [ -n{bfinrv} ] [ -r ] [  -v
     ] [ -o file ] [ file1 ] [ file2 ] [...]

DESCRIPTION
     a2ps formats files "file1", "file2", ... for printing  in  a
     postscript printer; if no file is given, a2ps reads from the
     standard input.  Format used is very nice and  compact:  two
     pages  on  each  physical  page,  borders surrounding pages,
     headers with useful information (page number, printing date,
     file  name),  line  numbering,  etc.  Very useful to archive
     listings of programs.

     Options offered by a2ps are the following:

     -b    Force printing binary files. By default, binary  files
           printing  is  stopped  before  second  page  (see  -nb
           option).

     -f    Fold lines too large to be printed inside the  borders
           (default option).  Max size is actually 86 characters.

     -i    Interpret TAB, BS and FF characters (default  option).
           TAB  is  replaced  by  enough spaces to reach next tab
           stop while BS and FF have their meanings.

     -n    Output lines are preceded by  line  numbers,  numbered
           sequentially from 1 (default option).

     -nb   Don't print binary files. To detect  such  a  file  we
           make use of a very simple heuristic: if the first page
           of the file contains at less 75% of non-printing char-
           acters,  it's  a  binary  file.  First  page is always
           printed.

     -nf   Cut lines too large (don't fold).

     -ni   Don't interpret TAB, BS and FF characters.  They  will
           be printed according to -v option.

     -nn   Don't number output lines.

     -nr   Sheet numbering (see -r option) must be  continue  for
           all files (don't reset on new file).

     -nv   Replace non-printing characters by a space.

     -r    Reset sheet  numbering  for  each  new  file  (default










A2PS(1L)



           option).  Sheet  numbering  is used to number physical
           pages (sheets printed) and is placed in the bottom  of
           each  physical  page.  It differs from page numbering:
           logical pages of file been printed.

     -v    Replace non-printing characters so that they are lisi-
           ble  and  easy  to  identify (default option). Control
           characters (ascii codes lower than 0x20)  are  printed
           like ^X for ctrl-x; the delete character (hex 0x3f) is
           printed as ^?. Non ascii characters (with the high bit
           set)  are  printed  as  M-  (for meta) followed by the
           character of the low 7 bits. TAB, BS and FF  are  han-
           dled  like  non-printing  characters if -ni option was
           taked.

     -o    The next argument is taken as the output file name.

USAGE
     a2ps sends formatted file to standard output, unless the  -o
     command  is given. User could redirect this output to a file
     or pipe it directly to a print command, like lpr in UNIX:

          a2ps file1 > file2

          a2ps -o file2 file1

          a2ps file1 | lpr -l

     Don't forget -l option in last line, if you  want  that  lpr
     interprets your postscript program.

     This filter must be used only with text  files.  Avoid  spe-
     cially output from TeX, troff or any other text formatter.

SEE ALSO
     pprps(1L) tgrind(1) lpr(1)

AUTHORS
     Evan Kirshenbaum (evan@csli) for the initial version.
     Miguel Santana (miguel@imag.imag.fr) for 2.0 version.



















